Skip to navigation

Update a subscription

View as Markdown

Use this call to make the following kinds of changes to a subscription:

  • Add a note
  • Change the renewal term or auto-renewal flag
  • Change the term length or change between evergreen and termed
  • Add a new product rate plan
  • Remove an existing subscription rate plan
  • Change the quantity or price of an existing subscription rate plan
  • Change rate plans - to replace the existing rate plans in a subscription with other rate plans. Changing rate plans is currently not supported for the Billing - Revenue Integration feature. When Billing - Revenue Integration is enabled, changing rate plans will no longer be applicable in Zuora Billing.

Notes:

  • The “Update a subscription” call creates a new subscription object that has a new version number and to which the subscription changes are applied. The new subscription object has the same subscription name but a new, different, subscription ID. The Status field of the new subscription object will be set to Active unless the change applied was a cancelation or suspension in which case the status reflects that. The Status field of the originating subscription object changes from Active to Expired. A status of Expired does not imply that the subscription itself has expired or ended, merely that this subscription object is no longer the most recent.

  • In one request, this call can make:

    • Up to 9 combined add, update, and remove changes
    • No more than 1 change to terms & conditions
  • Updates are performed in the following sequence:

    1. First change the notes on the existing subscription, if requested.
    2. Then change the terms and conditions, if requested.
    3. Then perform the remaining amendments based upon the effective dates specified. If multiple amendments have the same contract-effective dates, then execute adds before updates, and updates before removes.
  • The update operation is atomic. If any of the updates fails, the entire operation is rolled back.

  • The response of the Update Subscription call is based on the REST API minor version you set in the request header. The response structure might be different if you use different minor version numbers.

  • If you have the Invoice Settlement feature enabled, it is best practice to set the Zuora-Version parameter to 211.0 or later available versions. Otherwise, an error occurs.

Override a Tiered Price

There are two ways you override a tiered price:

  • Override a specific tier number. For example: tiers[{tier:1,price:8},{tier:2,price:6}]
  • Override the entire tier structure. For example: tiers[{tier:1,price:8,startingUnit:1,endingUnit:100,priceFormat:"FlatFee"}, {tier:2,price:6,startingUnit:101,priceFormat:"FlatFee"}]

If you just override a specific tier, do not include the startingUnit field in the request.

Authentication

AuthorizationBearer

Use Bearer {{token}} in the Authorization header for authentication.

Path parameters

subscription-keystringRequired

Subscription number or ID. ID can be the latest version or any history version of ID.

Headers

Accept-EncodingstringOptional

Include the Accept-Encoding: gzip header to compress responses as a gzipped file. It can significantly reduce the bandwidth required for a response.

If specified, Zuora automatically compresses responses that contain over 1000 bytes of data, and the response contains a Content-Encoding header with the compression algorithm so that your client can decompress it.

Content-EncodingstringOptional

Include the Content-Encoding: gzip header to compress a request. With this header specified, you should upload a gzipped file for the request payload instead of sending the JSON payload.

Zuora-Track-IdstringOptional<=64 characters

A custom identifier for tracing the API call. If you set a value for this header, Zuora returns the same value in the response headers. This header enables you to associate your system process identifiers with Zuora API calls, to assist with troubleshooting in the event of an issue.

The value of this field must use the US-ASCII character set and must not include any of the following characters: colon (:), semicolon (;), double quote ("), and quote (').

Zuora-Entity-IdsstringOptional

An entity ID. If you have Zuora Multi-entity enabled and the OAuth token is valid for more than one entity, you must use this header to specify which entity to perform the operation in. If the OAuth token is only valid for a single entity, or you do not have Zuora Multi-entity enabled, you should not set this header.

Zuora-Org-IdsstringOptional

Comma separated IDs. If you have Zuora Multi-Org enabled, you can use this header to specify which orgs to perform the operation in. If you do not have Zuora Multi-Org enabled, you should not set this header.

The IDs must be a sub-set of the user’s accessible orgs. If you specify an org that the user does not have access to, the operation fails. This header is important in Multi-Org (MO) setups because it defines the organization context under which the API should operate—mainly used for read access or data visibility filtering. If the header is not set, the operation is performed in scope of the user’s accessible orgs.

Zuora-VersionstringOptional

The minor API version.

For a list of available minor versions, see API upgrades.

Request

This endpoint expects an object.
addlist of objectsOptional
Container for adding one or more rate plans.
applicationOrderlist of stringsOptional

The priority order to apply credit memos and/or unapplied payments to an invoice. Possible item values are: CreditMemo, UnappliedPayment.

Note:

  • This field is valid only if the applyCredit field is set to true.
  • If no value is specified for this field, the default priority order is used, [“CreditMemo”, “UnappliedPayment”], to apply credit memos first and then apply unapplied payments.
  • If only one item is specified, only the items of the spedified type are applied to invoices. For example, if the value is ["CreditMemo"], only credit memos are used to apply to invoices.
applyCreditbooleanOptional

Whether to automatically apply credit memos or unapplied payments, or both to an invoice.

If the value is true, the credit memo or unapplied payment, or both will be automatically applied to the invoice. If no value is specified or the value is false, no action is taken.

Note: This field is only available if you have Invoice Settlement enabled. The Invoice Settlement feature is generally available as of Zuora Billing Release 296 (March 2021). This feature includes Unapplied Payments, Credit and Debit Memo, and Invoice Item Settlement. If you want to enable Invoice Settlement, see Invoice Settlement Enablement and Checklist Guide for more information.

applyCreditBalancebooleanOptional

Whether to automatically apply a credit balance to an invoice.

If the value is true, the credit balance is applied to the invoice. If the value is false, no action is taken.

To view the credit balance adjustment, retrieve the details of the invoice using the Get Invoices method.

Prerequisite: invoice must be true.

Note:

  • If you are using the field invoiceCollect rather than the field invoice, the invoiceCollect value must be true.
  • This field is deprecated if you have the Invoice Settlement feature enabled.
autoRenewbooleanOptional

If true, this subscription automatically renews at the end of the subscription term. Default is false.

bookingDatedateOptional

The booking date that you want to set for the contract when you change the termType field of the subscription and as a result get a new version of subscription created. The booking date of an amendment is the equivalent of the order date of an order. This field must be in the yyyy-mm-dd format. The default value is the current date when you make the API call.

changelist of objectsOptional

Use this field to change one or more rate plans - to replace the existing rate plans in a subscription with other rate plans.

Note: Changing rate plans is currently not supported for the Billing - Revenue Integration feature. When Billing - Revenue Integration is enabled, changing rate plans will no longer be applicable in Zuora Billing.

collectbooleanOptionalDefaults to false

Collects an automatic payment for a subscription. The collection generated in this operation is only for this subscription, not for the entire customer account.

If the value is true, the automatic payment is collected. If the value is false, no action is taken.

Prerequisite: The invoice or runBilling field must be true.

Note: This field is available only if you are on the latest Zuora API version, or you set the Zuora-Version request header to 196.0 or a later available version.

creditMemoReasonCodestringOptional
A code identifying the reason for the credit memo transaction that is generated by the request. The value must be an existing reason code. If you do not pass the field or pass the field with empty value, Zuora uses the default reason code.
currentTermlongOptional

The length of the period for the current subscription term. If termType is TERMED, this field is required and must be greater than 0. If termType is EVERGREEN, this value is ignored.

currentTermPeriodTypestringOptional

The period type for the current subscription term.

This field is used with the CurrentTerm field to specify the current subscription term.

Values are:

  • Month (default)
  • Year
  • Day
  • Week
documentDatedateOptional

The date of the billing document, in yyyy-mm-dd format. It represents the invoice date for invoices, credit memo date for credit memos, and debit memo date for debit memos.

  • If this field is specified, the specified date is used as the billing document date.
  • If this field is not specified, the date specified in the targetDate is used as the billing document date.
externallyManagedByenumOptional

An enum field on the Subscription object to indicate the name of a third-party store. This field is used to represent subscriptions created through third-party stores.

Allowed values:
includeExistingDraftDocItemsbooleanOptional

Specifies whether to include draft invoice items in subscription previews. Values are:

  • true (default). Includes draft invoice items in the preview result.
  • false. Excludes draft invoice items in the preview result.

Note: This field is available only if you are on the latest Zuora API version, or you set the Zuora-Version request header to 207.0 or a later available version.

invoiceSeparatelybooleanOptional

Separates a single subscription from other subscriptions and invoices the charge independently.

If the value is true, the subscription is billed separately from other subscriptions. If the value is false, the subscription is included with other subscriptions in the account invoice.

The default value is false. Prerequisite: The default subscription setting Enable Subscriptions to be Invoiced Separately must be set to Yes.

notesstringOptional<=1000 characters
The notes for the subscription.
previewbooleanOptional

If true the update is made in preview mode. The default setting is false.

previewTypeenumOptionalDefaults to LegalDoc

The type of preview you will receive.

Note: If your API minor version is earlier than 206.0 or you specify the Zuora-Version header for this request to 206.0 or earlier, the following values are supported for the previewType field:

  • InvoiceItem (default)
  • ChargeMetrics
  • InvoiceItemChargeMetrics
Allowed values:
removelist of objectsOptional
Container for removing one or more rate plans.
renewalSettingstringOptional

Specifies whether a termed subscription will remain TERMED or change to EVERGREEN when it is renewed.

Values are:

  • RENEW_WITH_SPECIFIC_TERM (default)
  • RENEW_TO_EVERGREEN
renewalTermlongOptional

The length of the period for the subscription renewal term. Default is 0.

renewalTermPeriodTypestringOptional

The period type for the subscription renewal term.

This field is used with the renewalTerm field to specify the subscription renewal term.

Values are:

  • Month (default)
  • Year
  • Day
  • Week
runBillingbooleanOptionalDefaults to false

Creates an invoice for a subscription. If you have the Invoice Settlement feature enabled, a credit memo might also be created based on the invoice and credit memo generation rule.

The billing documents generated in this operation is only for this subscription, not for the entire customer account.

This field is available only if you are on the latest Zuora API version, or you set the Zuora-Version request header to 211.0 or a later available version.

Possible values:

  • true: An invoice is created. If you have the Invoice Settlement feature enabled, a credit memo might also be created.

  • false: No invoice is created.

targetDatedateOptional

Date through which to calculate charges if an invoice or a credit memo is generated, as yyyy-mm-dd. Default is current date.

Note: The credit memo is only available if you have the Invoice Settlement feature enabled.

This field is available only if you are on the latest Zuora API minor version, or you set the Zuora-Version request header to 211.0 or a later available version.

termStartDatedateOptional

Date the subscription term begins, as yyyy-mm-dd. If this is a renewal subscription, this date is different from the subscription start date.

termTypestringOptional

Possible values are: TERMED, EVERGREEN.

updatelist of objectsOptional
Container for updating one or more rate plans.
CpqBundleJsonId__QTstringOptional<=32 characters
The Bundle product structures from Zuora Quotes if you utilize Bundling in Salesforce. Do not change the value in this field.
OpportunityCloseDate__QTdateOptional
The closing date of the Opportunity. This field is used in Zuora data sources to report on Subscription metrics. If the subscription originated from Zuora Quotes, the value is populated with the value from Zuora Quotes.
OpportunityName__QTstringOptional<=100 characters
The unique identifier of the Opportunity. This field is used in Zuora data sources to report on Subscription metrics. If the subscription originated from Zuora Quotes, the value is populated with the value from Zuora Quotes.
QuoteBusinessType__QTstringOptional<=32 characters
The specific identifier for the type of business transaction the Quote represents such as New, Upsell, Downsell, Renewal or Churn. This field is used in Zuora data sources to report on Subscription metrics. If the subscription originated from Zuora Quotes, the value is populated with the value from Zuora Quotes.
QuoteNumber__QTstringOptional<=32 characters
The unique identifier of the Quote. This field is used in Zuora data sources to report on Subscription metrics. If the subscription originated from Zuora Quotes, the value is populated with the value from Zuora Quotes.
QuoteType__QTstringOptional<=32 characters
The Quote type that represents the subscription lifecycle stage such as New, Amendment, Renew or Cancel. This field is used in Zuora data sources to report on Subscription metrics. If the subscription originated from Zuora Quotes, the value is populated with the value from Zuora Quotes.
IntegrationId__NSstringOptional<=255 characters

ID of the corresponding object in NetSuite. Only available if you have installed the Zuora Connector for NetSuite.

IntegrationStatus__NSstringOptional<=255 characters

Status of the subscription’s synchronization with NetSuite. Only available if you have installed the Zuora Connector for NetSuite.

Project__NSstringOptional<=255 characters

The NetSuite project that the subscription was created from. Only available if you have installed the Zuora Connector for NetSuite.

SalesOrder__NSstringOptional<=255 characters

The NetSuite sales order than the subscription was created from. Only available if you have installed the Zuora Connector for NetSuite.

SyncDate__NSstringOptional<=255 characters

Date when the subscription was synchronized with NetSuite. Only available if you have installed the Zuora Connector for NetSuite.

Response headers

Content-EncodingstringOptional

This header is returned if you specify the Accept-Encoding: gzip request header and the response contains over 1000 bytes of data.

Note that only the following MIME types support gzipped responses:

  • application/json
  • application/xml
  • text/html
  • text/csv
  • text/plain
RateLimit-LimitstringOptional

The request limit quota for the time window closest to exhaustion. See rate limits for more information.

RateLimit-Remainingdouble

The number of requests remaining in the time window closest to quota exhaustion. See rate limits for more information.

RateLimit-Resetdouble

The number of seconds until the quota resets for the time window closest to quota exhaustion. See rate limits for more information.

Zuora-Request-IdstringOptional
The Zuora internal identifier of the API call. You cannot control the value of this header.
Zuora-Track-IdstringOptional
A custom identifier for tracing the API call. If you specified a tracing identifier in the request headers, Zuora returns the same tracing identifier. Otherwise, Zuora does not set this header.
Concurrency-Limit-TypestringOptional

The type of the concurrency limit, which can be Default, High-volume transactions, or Object Query.

For more information, see Concurrent request limits.

Concurrency-Limit-Limitinteger

The total number of the permitted concurrent requests.

For more information, see Concurrent request limits.

Concurrency-Limit-Remaininginteger

The remaining number of the permitted concurrent requests.

For more information, see Concurrent request limits.

Response

OK
chargeMetricsobjectOptional

Container for charge metrics. This field is available only if the preview field in the request body is true.

creditMemoobjectOptional

Container for credit memos. This field is available only if the preview field in the request body is true.

Note: This container is only available if you set the Zuora REST API minor version to 207.0 or later available versions in the request header, and you have Invoice Settlement enabled. The Invoice Settlement feature is generally available as of Zuora Billing Release 296 (March 2021). This feature includes Unapplied Payments, Credit and Debit Memo, and Invoice Item Settlement. If you want to enable Invoice Settlement, see Invoice Settlement Enablement and Checklist Guide for more information.

creditMemoIdstringOptional

The credit memo ID. This field is available only if the preview field in the request body is false and a credit memo is generated during the update.

Note: This container is only available if you set the Zuora REST API minor version to 207.0 or later available versions in the request header, and you have Invoice Settlement enabled. The Invoice Settlement feature is generally available as of Zuora Billing Release 296 (March 2021). This feature includes Unapplied Payments, Credit and Debit Memo, and Invoice Item Settlement. If you want to enable Invoice Settlement, see Invoice Settlement Enablement and Checklist Guide for more information.

invoiceobjectOptional

Container for invoices. This field is available only if the preview field in the request body is true.

Note: This field is available only if you are on the latest Zuora API version, or you set the Zuora-Version request header to 207.0 or a later available version. Also, the response structure is changed and the following invoice related response fields are moved to this invoice container:

  • amount
  • amountWithoutTax
  • taxAmount
  • invoiceItems
  • targetDate
invoiceIdstringOptional

The ID of the generated invoice.

This field is available only if the preview field in the request body is false and an invoice is generated during the update.

invoiceItemslist of objectsOptional

Container for invoice items. This field is available only if the preview field in the request body is true.

paidAmountdoubleOptional
Payment amount, if a payment is collected
paymentIdstringOptional
Payment ID, if a payment is collected.
subscriptionIdstringOptional
The ID of the resulting new subscription.
successbooleanOptional

Returns true if the request was processed successfully.

targetDatedateOptional

Date through which to calculate charges if an invoice is generated, as yyyy-mm-dd. Default is current date. This field is available only if the preview field in the request body is true.

Note: This field is only available if you are on the latest Zuora API minor version, or you set the Zuora-Version request header to 207.0 or a later available version.

taxAmountdoubleOptional

Tax amount on the invoice. This field is available only if the preview field in the request body is true.

totalDeltaMrrdoubleOptional
Change in the subscription monthly recurring revenue as a result of the update.
totalDeltaTcvdoubleOptional
Change in the total contracted value of the subscription as a result of the update.

Errors

4XX
Client Request Error
500
Internal Server Error